﻿//-----------------------------------------------
//TUSB-S01ACC用ドライバアクセス用API
//Visual C# 用モジュール
//
//2013_10_17　株式会社タートル工業
//Copyright (C) 2013 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBSACC
{
    //API関数宣言

    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Device_Open(short id);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbs01acc_Device_Close(short id);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Timer_Set(short id,byte ClockN,int ClockM);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Input_Set(short id,byte HPE,byte Range);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Sampling_Start(short id,byte TrType,short Level,int PreLen,int TotalLen);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Status_Read(short id,out byte status,out byte ovf,out int leng);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Memory_Read(short id, [Out] short[] data,ref int leng);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Sampling_Stop(short id);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Memory_Clear(short id);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_Sampling_Trigger(short id);
    [DllImport("TUSBSACC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01acc_FifoPeak(short id,out byte Peak);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

