﻿'-----------------------------------------------
'TUSB-S01ACC用ドライバアクセス用API
'Visual Basic 標準モジュール
'
'2013_10_17　株式会社タートル工業
'Copyright (C) 2013 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Module TUSBSACC

    'API関数宣言
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Device_Open( _
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub Tusbs01acc_Device_Close( _
                                ByVal id As Short)
    End Sub
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Timer_Set( _
                                ByVal id As Short, _
                                ByVal ClockN As Byte, _
                                ByVal ClockM As Integer) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Input_Set( _
                                ByVal id As Short, _
                                ByVal HPF As Byte, _
                                ByVal Range As Byte) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Sampling_Start( _
                                ByVal id As Short, _
                                ByVal TrType As Byte, _
                                ByVal Level As Short, _
                                ByVal PreLen As Integer, _
                                ByVal TotalLen As Integer) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Status_Read( _
                                ByVal id As Short, _
                                ByRef status As Byte, _
                                ByRef ovf As Byte, _
                                ByRef leng As Integer) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Memory_Read( _
                                ByVal id As Short, _
                                <[In](), Out()> ByVal data() As Short, _
                                ByRef leng As Integer) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Sampling_Stop( _
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Memory_Clear( _
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_Sampling_Trigger( _
                                ByVal id As Short) _
                            As Short
    End Function
    <DllImport("TUSBSACC.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbs01acc_FifoPeak( _
                                ByVal id As Short, _
                                ByRef Peak As Byte) _
                            As Short
    End Function

    'エラーメッセージ出力
    Function Tusbs01lacc_GetErrMessage(ByVal retcode As Short) As String
        Select Case retcode
            Case 0
                Return "正常終了しました"
            Case 1
                Return "ID番号が不正です"
            Case 2
                Return "ドライバがインストールされていません"
            Case 3
                Return "すでにデバイスはオープンされています"
            Case 4
                Return "接続されている台数が多すぎます"
            Case 5
                Return "オープンできませんでした"
            Case 6
                Return "デバイスがみつかりません"
            Case 7
                Return "オープンされていません"
            Case 8
                Return "パラメータエラー"
            Case 9
                Return "USB通信エラーです"
            Case Else
                Return "不明なエラーです"
        End Select
    End Function
End Module