﻿Public Class Form1
    Private SaveFile As IO.StreamWriter ' 保存ファイルストリーム
    Private SamplingStopFlg As Boolean '中止指示フラグ Trueで中止
    Private SamplingStatus As Short '動作状態 0:停止 1:トリガ待ち 2:データ取得中
    Private tmpSampleDataBuf() As Short 'データ取り込み用
    Private SampledLen As Integer    '取り込み済みデータ数

    Private Sub Form1_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If OPEN_CLOSE_Btn.Text = "CLOSE" Then 'オープンされている時
            If Sampling_Stop_Btn.Enabled Then 'サンプリング動作中の時
                SamplingStop() '停止
            End If
            DeviceClose() 'デバイスを閉じる
        End If
    End Sub

    '画面表示制御
    'state 0:クローズ状態 1:オープン状態 2:サンプリング中
    Private Sub EnableDisableCont(ByVal state As Integer)
        Select Case state
            Case 0 '非オープン
                Timer_Set_Btn.Enabled = False
                Input_Set_Btn.Enabled = False
                Sampling_Start_Btn.Enabled = False
                Sampling_Stop_Btn.Enabled = False
                Soft_Trigger_Btn.Enabled = False
                ID_SEL.Enabled = True
                OPEN_CLOSE_Btn.Enabled = True
            Case 1 'オープン　サンプリング停止時
                Timer_Set_Btn.Enabled = True
                Input_Set_Btn.Enabled = True
                Sampling_Start_Btn.Enabled = True
                Sampling_Stop_Btn.Enabled = False
                Soft_Trigger_Btn.Enabled = False
                ID_SEL.Enabled = False
                OPEN_CLOSE_Btn.Enabled = True
            Case 2 'オープン　サンプリング動作時
                Timer_Set_Btn.Enabled = False
                Input_Set_Btn.Enabled = False
                Sampling_Start_Btn.Enabled = False
                Sampling_Stop_Btn.Enabled = True
                Soft_Trigger_Btn.Enabled = True
                ID_SEL.Enabled = False
                OPEN_CLOSE_Btn.Enabled = False
        End Select
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        SamplingStatus = 0 'サンプリング動作状態　停止
        ID_SEL.SelectedIndex = 0 'IDの初期値を0とする
        Clock_M.Text = CStr(480) 'タイマー1/480
        Clock_N.SelectedIndex = 0 'タイマー指数部 0
        HPF.SelectedIndex = 0 'HPF 0.1Hz
        GAIN.SelectedIndex = 0 'GAIN ×1
        TriggerSel.SelectedIndex = 0 'トリガ選択 ソフトトリガ
        TriggerLevel.Text = "0" 'トリガレベル 0
        PreTriggerLen.Text = "0" 'プレトリガ長 0
        BufferLen.Text = "1000" '取り込み長1000
        EnableDisableCont(0) '画面イネーブル制御
        ReDim tmpSampleDataBuf(100000) '作業用バッファ取得
    End Sub

    Private Sub Timer_Set_Btn_Click(sender As System.Object, e As System.EventArgs) Handles Timer_Set_Btn.Click
        Dim ret As Short
        Dim N As Byte
        Dim M As Integer

        N = Clock_N.SelectedIndex '乗数Nの取得
        If IsNumeric(Clock_M.Text) Then '整数Mのチェック
            M = CInt(Clock_M.Text) '整数Mの取得
        Else
            MsgBox("Please input an integer into 'M'.")
            Exit Sub
        End If

        ret = Tusbs01acc_Timer_Set(ID_SEL.SelectedIndex, N, M) 'タイマー設定

        '結果の表示
        If ret = 0 Then
            StatusMessage.Text = "<Timer_Set> Complete."
        Else
            MsgBox(Tusbs01lacc_GetErrMessage(Ret))
        End If
    End Sub

    Private Sub Input_Set_Btn_Click(sender As System.Object, e As System.EventArgs) Handles Input_Set_Btn.Click
        Dim ret As Short
        ret = Tusbs01acc_Input_Set(CShort(ID_SEL.Text), HPF.SelectedIndex, GAIN.SelectedIndex) '設定

        '結果の表示
        If ret = 0 Then
            StatusMessage.Text = "<Input_Set> Complete."
        Else
            MsgBox(Tusbs01lacc_GetErrMessage(Ret))
        End If
    End Sub

    Private Sub Sampling_Start_Btn_Click(sender As System.Object, e As System.EventArgs) Handles Sampling_Start_Btn.Click
        Dim ret As Short
        Dim Level As Short
        Dim PreLen As Integer
        Dim TotalLen As Integer

        If IsNumeric(TriggerLevel.Text) Then 'トリガレベル入力
            Level = CShort(TriggerLevel.Text)
        Else
            MsgBox("Please input an integer into 'Trigger Level'.")
            Exit Sub
        End If

        If IsNumeric(PreTriggerLen.Text) Then 'プレトリガ長入力
            PreLen = CInt(PreTriggerLen.Text)
        Else
            MsgBox("Please input an integer into 'Pre Trigger'.")
            Exit Sub
        End If

        If IsNumeric(BufferLen.Text) Then 'バッファ長入力
            TotalLen = CInt(BufferLen.Text)
        Else
            MsgBox("Please input an integer into 'Buffer Len'.")
            Exit Sub
        End If

        SaveFileDialog1.OverwritePrompt = True
        SaveFileDialog1.Filter = "データファイル(*.csv)|*.csv"
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then '保存ファイル名等を取得
            If IO.File.Exists(SaveFileDialog1.FileName) Then '既存ファイルチェック
                IO.File.Delete(SaveFileDialog1.FileName)
            End If

            SaveFile = New IO.StreamWriter(IO.File.OpenWrite(SaveFileDialog1.FileName)) 'ファイルを開く
            ret = Tusbs01acc_Sampling_Start(ID_SEL.SelectedIndex, TriggerSel.SelectedIndex, Level, PreLen, TotalLen) 'スタート

            If ret = 0 Then '正常に開始できた場合
                StatusMessage.Text = "Waiting for trigger."
                EnableDisableCont(2) '画面表示制御
                SamplingStopFlg = False '中止指示フラグ初期化
                SamplingStatus = 1 'トリガ待ちステータス
                Timer1.Interval = 100 '100mSタイマー
                SampledLen = 0
                Timer1.Enabled = True 'タイマー開始
            Else
                SaveFile.Close()
                MsgBox(Tusbs01lacc_GetErrMessage(ret)) 'エラー発生
            End If
        End If
    End Sub

    Private Sub Sampling_Stop_Btn_Click(sender As System.Object, e As System.EventArgs) Handles Sampling_Stop_Btn.Click
        SamplingStopFlg = True '中止指示フラグ
    End Sub

    Private Sub Soft_Trigger_Btn_Click(sender As System.Object, e As System.EventArgs) Handles Soft_Trigger_Btn.Click
        Dim ret As Short

        ret = Tusbs01acc_Sampling_Trigger(CShort(ID_SEL.Text)) 'トリガ発生

        '結果の表示
        If ret = 0 Then
        Else
            MsgBox(Tusbs01lacc_GetErrMessage(Ret))
        End If
    End Sub

    'デバイスのオープンに関わる処理
    Private Sub DeviceOpen()
        Dim ret As Short
        ret = Tusbs01acc_Device_Open(ID_SEL.SelectedIndex) '開く

        '結果の表示
        If ret = 0 Then
            EnableDisableCont(1) '正常にオープンできた
            OPEN_CLOSE_Btn.Text = "CLOSE"
        Else 'オープンできなかった
            MsgBox(Tusbs01lacc_GetErrMessage(Ret)) 'エラーメッセージ表示
        End If
    End Sub

    'デバイスのクローズに関わる処理
    Private Sub DeviceClose()
        Tusbs01acc_Device_Close(ID_SEL.SelectedIndex) '閉じる
        EnableDisableCont(0) '画面表示制御
        OPEN_CLOSE_Btn.Text = "OPEN"
    End Sub

    Private Sub OPEN_CLOSE_Btn_Click(sender As System.Object, e As System.EventArgs) Handles OPEN_CLOSE_Btn.Click
        If OPEN_CLOSE_Btn.Text = "OPEN" Then 'OPENならば
            DeviceOpen()
        Else 'CLOSEならば
            DeviceClose()
        End If
    End Sub

    '取り込み停止時の処理
    Private Sub SamplingStop()
        Dim cnt As Integer
        Dim ret As Short
        Dim leng As Integer

        ret = Tusbs01acc_Sampling_Stop(CShort(ID_SEL.Text)) '取り込み停止

        '結果の表示
        If ret Then
            MsgBox(Tusbs01lacc_GetErrMessage(Ret))
        Else
            StatusMessage.Text = "<Sapling> Stop"
        End If

        '最終データの保存
        Do
            leng = 100000
            ret = Tusbs01acc_Memory_Read(CShort(ID_SEL.Text), tmpSampleDataBuf, leng) '読み出し
            If ret Then
                MsgBox(Tusbs01lacc_GetErrMessage(Ret))
            Else
                For cnt = 0 To leng - 1
                    SaveFile.WriteLine(tmpSampleDataBuf(cnt)) '保存
                Next cnt
            End If
        Loop While ((leng <> CDbl(0)) And (ret = 0)) '長さ0以外でかつエラーでない場合

        SaveFile.Close() 'ファイルを閉じる
        EnableDisableCont(1) '画面表示制御
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim ret As Short
        Dim status As Byte
        Dim ovf As Byte
        Dim leng As Integer
        Dim cnt As Integer

        Select Case SamplingStatus
            Case 0 '停止状態
                Timer1.Enabled = False
            Case 1 'トリガ待ち状態
                If SamplingStopFlg Then '停止要求
                    Timer1.Enabled = False 'タイマー停止
                    SamplingStop() '取り込み停止
                Else
                    ret = Tusbs01acc_Status_Read(CShort(ID_SEL.Text), status, ovf, leng) '状態確認

                    '結果の表示
                    If ret Then
                        MsgBox(Tusbs01lacc_GetErrMessage(Ret)) 'エラーメッセージ
                        SamplingStop() '取り込み停止
                        SamplingStatus = 0 'サンプリング状態を0にする
                    Else
                        Select Case status
                            Case 0 'なんらかの理由で停止状態になった
                                Timer1.Enabled = False 'タイマー停止
                                SamplingStop() '取り込み停止
                                SamplingStatus = 0 'サンプリング状態を0にする
                            Case 2 'サンプリング中になった
                                StatusMessage.Text = "<Sapling>"
                                SamplingStatus = 2 'サンプリング状態を2にする
                        End Select
                    End If
                End If
            Case 2 '取り込み中
                If SamplingStopFlg Then '停止要求
                    Timer1.Enabled = False 'タイマー停止
                    SamplingStop() '取り込み停止
                Else
                    ret = Tusbs01acc_Status_Read(CShort(ID_SEL.Text), status, ovf, leng) '状態確認

                    '結果の表示
                    If ret Then
                        MsgBox(Tusbs01lacc_GetErrMessage(Ret)) 'エラーメッセージ
                        SamplingStop() '取り込み停止
                        SamplingStatus = 0 'サンプリング状態を0にする
                    Else
                        Select Case status
                            Case 0 'なんらかの理由で停止状態になった
                                Timer1.Enabled = False 'タイマー停止
                                SamplingStop() '取り込み停止
                                SamplingStatus = 0 'サンプリング状態を0にする
                            Case 2 'サンプリング中
                                leng = 100000 '一時取得バッファの長さ
                                ret = Tusbs01acc_Memory_Read(CShort(ID_SEL.Text), tmpSampleDataBuf, leng) 'データ取り込み
                                For cnt = 0 To leng - 1
                                    SaveFile.WriteLine(tmpSampleDataBuf(cnt)) 'ファイルへの書き込み
                                Next cnt
                                SampledLen = SampledLen + leng
                                StatusMessage.Text = Str(SampledLen)
                        End Select
                    End If
                End If
        End Select
    End Sub
End Class
